
local bCPUversion = 0.2

local hidden = true
local firstRun = true
local bCPU
local selected = nil
local showGraph = false
local data = {}
local detData = {}
local scaleMax = 15
local frameSkip = 1

-- Edit these if needed
local graphWidth = 500
local graphHeight = 200

local function CreateFrames()
	local bCPUcontext = UI.CreateContext("bCPUcontext")
	bCPU = UI.CreateFrame("Frame", "bCPU", bCPUcontext)
	bCPU:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 350)
	bCPU.width = 200
	bCPU.butHeight = 9
	bCPU:SetWidth(bCPU.width)
	
	bCPU:SetVisible(false)

end

local function Populate()
	
	bCPU.addonButtons = {}
	
	local nextPos = 0
	
	for k,v in pairs(Inspect.Addon.Cpu()) do
		bCPU.addonButtons[k] = UI.CreateFrame("Text", k .. "bCPUButton", bCPU)
		bCPU.addonButtons[k]:SetText(k)
		bCPU.addonButtons[k]:SetFontSize(15)
		bCPU.butHeight = bCPU.addonButtons[k]:GetHeight()
		bCPU.addonButtons[k]:SetWidth(bCPU.width)
		bCPU.addonButtons[k]:SetHeight(bCPU.butHeight)
		bCPU.addonButtons[k]:SetBackgroundColor(0,0,0,0.6)
		bCPU.addonButtons[k]:SetPoint("TOPLEFT", bCPU, "TOPLEFT", 0, nextPos)
		nextPos = nextPos + bCPU.butHeight
		
		bCPU:SetHeight(nextPos)
		
		local tot = 0
		
		for i,j in pairs(v) do
			tot = tot + j
		end
		tot=tot*100
		bCPU.addonButtons[k].CPU = UI.CreateFrame("Text", k .. "bCPUusage", bCPU)
		bCPU.addonButtons[k].CPU:SetPoint("TOPRIGHT", bCPU.addonButtons[k], "TOPRIGHT")
		bCPU.addonButtons[k].CPU:SetFontSize(13)
		bCPU.addonButtons[k]:SetLayer(1)
		bCPU.addonButtons[k].CPU:SetLayer(2)
		
		local tmp = bCPU.addonButtons[k]
		function tmp.Event.MouseIn()
			if selected ~= k then
				tmp:SetBackgroundColor(1,1,1,0.6)
			end
		end
		
		function tmp.Event.MouseOut()
			if selected ~= k then
				tmp:SetBackgroundColor(0,0,0,0.6)
			end
		end
		
		function tmp.Event.LeftClick()
			if selected then
				if bCPU.addonButtons[selected] == tmp then
					selected = nil
					data = {}
					tmp:SetBackgroundColor(0,0,0,0.6)
				else
					bCPU.addonButtons[selected]:SetBackgroundColor(0,0,0,0.6)
					data = {}
					selected = k
					tmp:SetBackgroundColor(0,0,1,0.6)
					bCPU.graphFrame:SetPoint("CENTERLEFT", bCPU.addonButtons[selected], "CENTERRIGHT", 5, 0)
				end
				for i=1,graphWidth do
					bCPU.graphFrame.graphBG.point[i]:SetHeight(0)
				end
			else
				selected = k
				tmp:SetBackgroundColor(0,0,1,0.6)
				bCPU.graphFrame:SetPoint("CENTERLEFT", bCPU.addonButtons[selected], "CENTERRIGHT", 5, 0)				
			end

		end
	end
	
	bCPU.graphButton = UI.CreateFrame("Text", "bCPUGraphButton", bCPU)
	bCPU.graphButton:SetText("Show graph")
	bCPU.graphButton:SetWidth(bCPU.width)
	bCPU.graphButton:SetFontSize(15)
	bCPU.graphButton:SetBackgroundColor(0,0,0,0.6)
	bCPU.graphButton:SetPoint("TOPLEFT", bCPU, "TOPLEFT", 0, nextPos)
	
	
	
	bCPU.graphFrame = UI.CreateFrame("Frame", "bCPUGraphFrame", bCPU)
	bCPU.graphFrame:SetVisible(false)
	bCPU.graphFrame:SetWidth(graphWidth + 50)
	bCPU.graphFrame:SetHeight(graphHeight + 20)
	bCPU.graphFrame:SetBackgroundColor(0,0,0,0.6)
	
	bCPU.graphFrame.graphBG = UI.CreateFrame("Frame", "bCPUGraph", bCPU.graphFrame)
	bCPU.graphFrame.graphBG:SetBackgroundColor(1,1,1,0.2)
	bCPU.graphFrame.graphBG:SetWidth(graphWidth)
	bCPU.graphFrame.graphBG:SetHeight(graphHeight)
	bCPU.graphFrame.graphBG:SetPoint("TOPLEFT", bCPU.graphFrame, "TOPLEFT", 40, 10)
	
	bCPU.graphFrame.graphBG.segment = {}
	bCPU.graphFrame.graphBG.segLab = {}
	
	local segment = graphHeight / 10
	for i=1,10 do
		bCPU.graphFrame.graphBG.segment[i] = UI.CreateFrame("Frame", "bCPUGraphSeg" .. i, bCPU.graphFrame.graphBG)
		bCPU.graphFrame.graphBG.segment[i]:SetBackgroundColor(1,1,1,0.2)
		bCPU.graphFrame.graphBG.segment[i]:SetHeight(1)
		bCPU.graphFrame.graphBG.segment[i]:SetWidth(graphWidth)
		bCPU.graphFrame.graphBG.segment[i]:SetPoint("CENTERLEFT", bCPU.graphFrame.graphBG, "BOTTOMLEFT", 0 , -i*segment)
		
		bCPU.graphFrame.graphBG.segLab[i] = UI.CreateFrame("Text", "bCPUGraphSegLab" .. i, bCPU.graphFrame.graphBG)
		bCPU.graphFrame.graphBG.segLab[i]:SetText(tostring((scaleMax/10)*i))
		bCPU.graphFrame.graphBG.segLab[i]:SetPoint("CENTERRIGHT", bCPU.graphFrame.graphBG, "BOTTOMLEFT", 0 , -i*segment)
	end
	
	bCPU.graphFrame.details = UI.CreateFrame("Frame", "bCPUdetails", bCPU.graphFrame)
	bCPU.graphFrame.details:SetWidth(graphWidth + 50)
	bCPU.graphFrame.details:SetPoint("BOTTOMLEFT", bCPU.graphFrame, "TOPLEFT", 0, 0)
	bCPU.graphFrame.details:SetBackgroundColor(0,0,0,0.6)
	
	bCPU.graphFrame.details:SetVisible(false)
	
	bCPU.graphFrame.details.labels = {}
	
	for i=0,4 do
		bCPU.graphFrame.details.labels[i] = UI.CreateFrame("Text", "bCPUdetailsLabel" .. i, bCPU.graphFrame.details)
		bCPU.graphFrame.details.labels[i]:SetText(" ")
		bCPU.graphFrame.details.labels[i]:SetPoint("TOPLEFT", bCPU.graphFrame.details, "TOPLEFT", 0, bCPU.graphFrame.details.labels[i]:GetHeight()*i)
	end
	bCPU.graphFrame.details:SetHeight(bCPU.graphFrame.details.labels[1]:GetHeight()*5)
	
	bCPU.graphFrame.graphBG.point = {}
	
	for i=1,graphWidth do 
		bCPU.graphFrame.graphBG.point[i] = UI.CreateFrame("Frame", "bCPUGraphPoint" .. i, bCPU.graphFrame.graphBG)
		bCPU.graphFrame.graphBG.point[i]:SetBackgroundColor(1,0,0,0.6)
		bCPU.graphFrame.graphBG.point[i]:SetWidth(1)
		bCPU.graphFrame.graphBG.point[i]:SetHeight(0)
		bCPU.graphFrame.graphBG.point[i]:SetPoint("BOTTOMCENTER", bCPU.graphFrame.graphBG, "BOTTOMRIGHT", -i, 0)
		
		local tmp = bCPU.graphFrame.graphBG.point[i]
		
		function tmp.Event.LeftClick()
			
			bCPU.graphFrame.details:SetVisible(true)
			
			local tmpData = {}
			for k,v in pairs(detData[i]) do
				table.insert(tmpData, {name = k, usage = v})
			end
			
			table.sort(tmpData, function(a,b) return a.usage > b.usage end)
			
			for i,v in ipairs(tmpData) do
				if i > 5 then break end
				bCPU.graphFrame.details.labels[i-1]:SetText(v.name .. ": " .. string.format("%.6f%%",v.usage*100))
			end
			
		end
	end
	
	function bCPU.graphButton.Event.MouseIn()
		if not showGraph then
			bCPU.graphButton:SetBackgroundColor(1,1,1,0.6)
		end
	end
	
	function bCPU.graphButton.Event.MouseOut()
		if not showGraph then
			bCPU.graphButton:SetBackgroundColor(0,0,0,0.6)
		end
	end
	
	function bCPU.graphButton.Event.LeftClick()
		if not showGraph then
			if selected then
				showGraph = true
				bCPU.graphFrame:SetPoint("CENTERLEFT", bCPU.addonButtons[selected], "CENTERRIGHT", 5, 0)
				bCPU.graphFrame:SetVisible(true)
				bCPU.graphButton:SetBackgroundColor(0,0,1,0.6)
			end
		else
			for i=0,4 do
				bCPU.graphFrame.details.labels[i]:SetText(" ")
			end
			bCPU.graphFrame.details:SetVisible(false)
			bCPU.graphFrame:SetVisible(false)
			showGraph = false
			bCPU.graphButton:SetBackgroundColor(0,0,0,0.6)
		end
	end
	
end

local function SetScale(newMax)
	if newMax < 0 then
		newMax = 1
	elseif newMax > 100 then
		newMax = 100
	end
	
	scaleMax = newMax
	
	for i=1,10 do
		bCPU.graphFrame.graphBG.segLab[i]:SetText(tostring((scaleMax/10)*i))
	end
	
end

local framesSinceUpdate = 0
local function Update()
	if selected or not hidden then
		for k,v in pairs(Inspect.Addon.Cpu()) do
			local tot = 0
			for i,j in pairs(v) do
				tot = tot + j
			end
			if k == selected and framesSinceUpdate >= frameSkip then
				framesSinceUpdate = 0
				table.insert(data, 1, tot)
				table.insert(detData, 1, v)
				if table.maxn(data) > graphWidth then
					table.remove(data, graphWidth+1)
					table.remove(detData, graphWidth+1)
				end
			elseif k == selected then
				framesSinceUpdate = framesSinceUpdate + 1
			end
			if not hidden then
				local newT = tot*100
				if newT < 1.50 then
					bCPU.addonButtons[k].CPU:SetFontColor(0,1,0)
				elseif newT < 5.0 then
					bCPU.addonButtons[k].CPU:SetFontColor(1,1,0)
				else
					bCPU.addonButtons[k].CPU:SetFontColor(1,0,0)
				end
				bCPU.addonButtons[k].CPU:SetText(string.format("%.2f%%", newT))
			end
		end
		
		if showGraph and framesSinceUpdate == 0 then
			for i=1,table.maxn(data) do
				local nH = ((data[i]*100)/scaleMax)*graphHeight
				if nH > graphHeight then
					nH = graphHeight
				end
				bCPU.graphFrame.graphBG.point[i]:SetHeight(nH)
			end
		end
		
	end
end

local function Slasher(args)
	if firstRun then
		Populate()
		firstRun = false
	end
	
	local argz = {}
	local totala = 0
	for cArg in string.gmatch(args, "[^%s]+") do
		argz[totala] = cArg
		totala=totala+1
	end
	
	if totala > 0 then
		if argz[0] == "scale" then
			SetScale(tonumber(argz[1]))
		elseif argz[0] == "frameskip" then
			frameSkip = tonumber(argz[1])
		end
	else
		hidden = not hidden
		bCPU:SetVisible(not hidden)
	end
end

local function AddonLoaded(addon)
	if addon == "bCPU" then
		CreateFrames()
		table.insert(Event.System.Update.Begin, { Update, "bCPU", "Update" } )
		print("bCPU " .. bCPUversion .. " loaded")
	end
end


table.insert(Event.Addon.Load.End, { AddonLoaded, "bCPU", "AddonLoaded" } )
table.insert(Command.Slash.Register("bcpu"), { Slasher, "bCPU", "Slasher" } )